Index: src/unittests/AnalysisCorrelationToPointUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision f8e48676b87bf0f42739924444d277b2d0744db3)
+++ src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision 4922793995be9d95cb066183ffb6f6bd1f01af1f)
@@ -44,7 +44,10 @@
   point = NULL;
 
-  // construct molecule (tetraeder of hydrogens)
+  // construct element list
+  std::vector<element *> elements;
   hydrogen = World::getInstance().getPeriode()->FindElement(1);
   CPPUNIT_ASSERT(hydrogen != NULL && "hydrogen element not found");
+  elements.push_back(hydrogen);
+  // construct molecule (tetraeder of hydrogens)
   TestMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
@@ -76,5 +79,5 @@
 
   // init maps
-  pointmap = CorrelationToPoint( (MoleculeListClass * const)TestList, (const element * const)hydrogen, (const Vector *)point );
+  pointmap = CorrelationToPoint( (MoleculeListClass * const)TestList, elements, (const Vector *)point );
   binmap = NULL;
 
Index: src/unittests/AnalysisCorrelationToPointUnitTest.hpp
===================================================================
--- src/unittests/AnalysisCorrelationToPointUnitTest.hpp	(revision f8e48676b87bf0f42739924444d277b2d0744db3)
+++ src/unittests/AnalysisCorrelationToPointUnitTest.hpp	(revision 4922793995be9d95cb066183ffb6f6bd1f01af1f)
@@ -37,5 +37,5 @@
       MoleculeListClass *TestList;
       molecule *TestMolecule;
-      const element *hydrogen;
+      element *hydrogen;
 
       CorrelationToPointMap *pointmap;
Index: src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision f8e48676b87bf0f42739924444d277b2d0744db3)
+++ src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision 4922793995be9d95cb066183ffb6f6bd1f01af1f)
@@ -52,6 +52,10 @@
   LC = NULL;
 
+  // prepare element list
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  CPPUNIT_ASSERT(hydrogen != NULL && "hydrogen element not found");
+  elements.clear();
+
   // construct molecule (tetraeder of hydrogens) base
-  hydrogen = World::getInstance().getPeriode()->FindElement(1);
   TestSurfaceMolecule = World::getInstance().createMolecule();
 
@@ -151,5 +155,6 @@
 {
   // do the pair correlation
-  surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
+  elements.push_back(hydrogen);
+  surfacemap = CorrelationToSurface( TestList, elements, Surface, LC );
 //  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   CPPUNIT_ASSERT( surfacemap != NULL );
@@ -160,5 +165,6 @@
 {
   BinPairMap::iterator tester;
-  surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
+  elements.push_back(hydrogen);
+  surfacemap = CorrelationToSurface( TestList, elements, Surface, LC );
   // put pair correlation into bins and check with no range
 //  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
@@ -175,5 +181,6 @@
 {
   BinPairMap::iterator tester;
-  surfacemap = CorrelationToSurface( TestList, hydrogen, Surface, LC );
+  elements.push_back(hydrogen);
+  surfacemap = CorrelationToSurface( TestList, elements, Surface, LC );
 //  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // ... and check with [0., 2.] range
@@ -193,5 +200,6 @@
 {
   BinPairMap::iterator tester;
-  surfacemap = CorrelationToSurface( TestList, carbon, Surface, LC );
+  elements.push_back(carbon);
+  surfacemap = CorrelationToSurface( TestList, elements, Surface, LC );
 //  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // put pair correlation into bins and check with no range
@@ -212,5 +220,6 @@
 {
   BinPairMap::iterator tester;
-  surfacemap = CorrelationToSurface( TestList, carbon, Surface, LC );
+  elements.push_back(carbon);
+  surfacemap = CorrelationToSurface( TestList, elements, Surface, LC );
 //  OutputCorrelationToSurface ( (ofstream *)&cout, surfacemap );
   // ... and check with [0., 2.] range
Index: src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp
===================================================================
--- src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision f8e48676b87bf0f42739924444d277b2d0744db3)
+++ src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision 4922793995be9d95cb066183ffb6f6bd1f01af1f)
@@ -45,6 +45,7 @@
       MoleculeListClass *TestList;
       molecule *TestSurfaceMolecule;
-      const element *hydrogen;
-      const element *carbon;
+      element *hydrogen;
+      element *carbon;
+      std::vector<element *> elements;
 
       CorrelationToSurfaceMap *surfacemap;
Index: src/unittests/AnalysisPairCorrelationUnitTest.cpp
===================================================================
--- src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision f8e48676b87bf0f42739924444d277b2d0744db3)
+++ src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision 4922793995be9d95cb066183ffb6f6bd1f01af1f)
@@ -47,6 +47,12 @@
   binmap = NULL;
 
+  // construct element list
+  std::vector<element *> elements;
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  CPPUNIT_ASSERT(hydrogen != NULL && "hydrogen element not found");
+  elements.push_back(hydrogen);
+  elements.push_back(hydrogen);
+
   // construct molecule (tetraeder of hydrogens)
-  hydrogen = World::getInstance().getPeriode()->FindElement(1);
   TestMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
@@ -75,5 +81,5 @@
 
   // init maps
-  correlationmap = PairCorrelation( TestList, hydrogen, hydrogen );
+  correlationmap = PairCorrelation( TestList, elements);
   binmap = NULL;
 
Index: src/unittests/AnalysisPairCorrelationUnitTest.hpp
===================================================================
--- src/unittests/AnalysisPairCorrelationUnitTest.hpp	(revision f8e48676b87bf0f42739924444d277b2d0744db3)
+++ src/unittests/AnalysisPairCorrelationUnitTest.hpp	(revision 4922793995be9d95cb066183ffb6f6bd1f01af1f)
@@ -37,5 +37,5 @@
       MoleculeListClass *TestList;
       molecule *TestMolecule;
-      const element *hydrogen;
+      element *hydrogen;
 
       PairCorrelationMap *correlationmap;