Index: tests/regression/Geometry/Remove/post/test.xyz
===================================================================
--- tests/regression/Geometry/Remove/post/test.xyz	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
+++ tests/regression/Geometry/Remove/post/test.xyz	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
@@ -0,0 +1,3 @@
+1
+	created for regression test InputToVector on 2017-03-31 10:07
+C	4	4	4
Index: tests/regression/Geometry/Remove/pre/test.xyz
===================================================================
--- tests/regression/Geometry/Remove/pre/test.xyz	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
+++ tests/regression/Geometry/Remove/pre/test.xyz	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
@@ -0,0 +1,3 @@
+1
+	created for regression test InputToVector on 2017-03-31 10:07
+C	2	2	2
Index: tests/regression/Geometry/Remove/testsuite-geometry-remove.at
===================================================================
--- tests/regression/Geometry/Remove/testsuite-geometry-remove.at	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
+++ tests/regression/Geometry/Remove/testsuite-geometry-remove.at	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
@@ -0,0 +1,61 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2017 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### remove
+
+AT_SETUP([Geometry - remove geometry])
+AT_KEYWORDS([geometry remove-geometry])
+file=test.xyz
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/regression/Geometry/Remove/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod +w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -v 5 \
+	--select-atom-by-id 0 --position-to-vector "testvector" --unselect-all-atoms \
+	--remove-geometry "testvector" \
+	--select-atom-by-element C --translate-atoms --position "testvector"], 5, [ignore], [ignore])
+AT_CLEANUP
+
+AT_SETUP([Geometry - remove invalid geometry])
+AT_KEYWORDS([geometry remove-geometry])
+file=test.xyz
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/regression/Geometry/Remove/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod +w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -v 5 \
+	--select-atom-by-id 0 --position-to-vector "testvector" --unselect-all-atoms \
+	--remove-geometry "zeroVector"], 5, [ignore], [ignore])
+AT_CLEANUP
+
+AT_SETUP([Geometry - remove geometry Undo])
+AT_KEYWORDS([geometry remove-geometry undo])
+file=test.xyz
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/regression/Geometry/Remove/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod +w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -v 5 \
+	--select-atom-by-id 0 --position-to-vector "testvector" --unselect-all-atoms \
+	--remove-geometry "testvector"  --undo \
+	--select-atom-by-element C --translate-atoms --position "testvector"], 0, [ignore], [ignore])
+AT_CHECK([diff -I '.*reated.*' $file ${abs_top_srcdir}/tests/regression/Geometry/Remove/post/$file], 0, [ignore], [ignore])
+AT_CLEANUP
+
+AT_SETUP([Geometry - remove geometry Redo])
+AT_KEYWORDS([geometry remove-geometry undo redo])
+file=test.xyz
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/regression/Geometry/Remove/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod +w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -v 5 \
+	--remove-geometry "testvector" --undo --redo \
+	--select-atom-by-element C --translate-atoms --position "testvector"], 5, [ignore], [ignore])
+AT_CLEANUP
Index: tests/regression/Geometry/testsuite-geometry.at
===================================================================
--- tests/regression/Geometry/testsuite-geometry.at	(revision f79d65a94e2c55cb0c7fb07298fa568980dbf8d4)
+++ tests/regression/Geometry/testsuite-geometry.at	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
@@ -32,2 +32,5 @@
 # Input to Vector
 m4_include([Geometry/InputToVector/testsuite-geometry-input-to-vector.at])
+
+# Remove
+m4_include([Geometry/Remove/testsuite-geometry-remove.at])
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision f79d65a94e2c55cb0c7fb07298fa568980dbf8d4)
+++ tests/regression/Makefile.am	(revision 8369728059c2b4573c012b488700f47b63c6bee4)
@@ -125,4 +125,5 @@
 	$(srcdir)/Geometry/PlaneToVector/testsuite-geometry-plane-to-vector.at \
 	$(srcdir)/Geometry/PositionToVector/testsuite-geometry-position-to-vector.at \
+	$(srcdir)/Geometry/Remove/testsuite-geometry-remove.at \
 	$(srcdir)/Graph/testsuite-graph.at \
 	$(srcdir)/Graph/CreateAdjacency/testsuite-graph-create-adjacency.at \