Index: src/UIElements/Views/Qt4/MoleculeList/QtObservedMoleculeObserver.cpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/QtObservedMoleculeObserver.cpp	(revision 9242598314ccb08531f6506da54bb5a30b948820)
+++ src/UIElements/Views/Qt4/MoleculeList/QtObservedMoleculeObserver.cpp	(revision 9242598314ccb08531f6506da54bb5a30b948820)
@@ -0,0 +1,62 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2016 Frederik Heber. All rights reserved.
+ *
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * QtObservedMoleculeObserver.cpp
+ *
+ *  Created on: Mar 17, 2016
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "QtObservedMoleculeObserver.hpp"
+#include "UIElements/Qt4/InstanceBoard/QtObservedInstanceBoard.hpp"
+
+#include "CodePatterns/MemDebug.hpp"
+
+QtObservedMoleculeObserver::QtObservedMoleculeObserver(
+    QtObservedInstanceBoard *_board,
+    QWidget * _parent) :
+    QWidget(_parent)
+{
+    connect(_board, SIGNAL(moleculeInserted(QtObservedMolecule::ptr)),
+        this, SIGNAL(MoleculeInserted(QtObservedMolecule::ptr)));
+    connect(_board, SIGNAL(moleculeRemoved(const moleculeId_t)),
+        this, SIGNAL(MoleculeRemoved(const moleculeId_t)));
+}
+
+void QtObservedMoleculeObserver::formulaChanged()
+{
+  QtObservedMolecule * const walker = static_cast<QtObservedMolecule *>(sender());
+  emit FormulaChanged(walker->getRef());
+}
+
+void QtObservedMoleculeObserver::nameChanged()
+{
+  QtObservedMolecule * const walker = static_cast<QtObservedMolecule *>(sender());
+  emit NameChanged(walker->getRef());
+}
Index: src/UIElements/Views/Qt4/MoleculeList/QtObservedMoleculeObserver.hpp
===================================================================
--- src/UIElements/Views/Qt4/MoleculeList/QtObservedMoleculeObserver.hpp	(revision 9242598314ccb08531f6506da54bb5a30b948820)
+++ src/UIElements/Views/Qt4/MoleculeList/QtObservedMoleculeObserver.hpp	(revision 9242598314ccb08531f6506da54bb5a30b948820)
@@ -0,0 +1,54 @@
+/*
+ * QtObservedMoleculeObserver.hpp
+ *
+ *  Created on: Mar 17, 2016
+ *      Author: heber
+ */
+
+
+#ifndef QTOBSERVEDMOLECULEOBSERVER_HPP_
+#define QTOBSERVEDMOLECULEOBSERVER_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <QWidget>
+
+#include "UIElements/Qt4/InstanceBoard/QtObservedMolecule.hpp"
+#include "types.hpp"
+
+class QtObservedInstanceBoard;
+
+/** This class serves all QtObservedMolecule instances and relays specific
+ * events, such as ElementChanged.
+ *
+ * This is to have single class that is informed about all changes of a
+ * certain type, but on the Qt side, just as EntityObserver does on the
+ * molecuilder side.
+ *
+ */
+class QtObservedMoleculeObserver : public QWidget
+{
+  Q_OBJECT
+
+public:
+  QtObservedMoleculeObserver(QtObservedInstanceBoard *_board, QWidget * _parent = NULL);
+
+signals:
+  void FormulaChanged(const QtObservedMolecule::ptr _atom);
+  void NameChanged(const QtObservedMolecule::ptr _atom);
+
+  // relayed signals
+  void MoleculeInserted(const QtObservedMolecule::ptr _atom);
+  void MoleculeRemoved(const atomId_t _atomid);
+
+private slots:
+  // relayed, and modified signals
+  void formulaChanged();
+  void nameChanged();
+
+};
+
+#endif /* QTOBSERVEDMOLECULEOBSERVER_HPP_ */